#ifndef MEM_OS_H
#define MEM_OS_H

#include "../../../common/aliases/aliases.h"
#include "../../../common/platform/platform.h"

#ifdef __cplusplus
BEGIN_C_LINKAGE
#endif // __cplusplus

#include "mem_os_ops.h"

#if defined(WAPP_PLATFORM_WINDOWS)
#include "win/mem_os_win.h"
#elif defined(WAPP_PLATFORM_POSIX)
#include "posix/mem_os_posix.h"
#else
#error "Unrecognised platform"
#endif

void *wapp_mem_util_align_forward(void *ptr, u64 alignment);
void *wapp_mem_util_alloc(void *addr, u64 size, MemAccess access, MemAllocFlags flags, MemInitType type);
void wapp_mem_util_free(void *ptr, u64 size);

external void *mem_util_allocate(void *addr, u64 size, MemAccess access, MemAllocFlags flags, MemInitType type);
external void mem_util_free(void *ptr, u64 size);

#ifdef __cplusplus
END_C_LINKAGE
#endif // __cplusplus

#endif // !MEM_OS_H
